'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               WinScape                                   |
'|                                                                          |
'|                            GDImage project                               |
'|                                                                          |
'|              With exclusive Skin Engine for VISTA and XP                 |
'|                       pushing the Windows limit.                         |
'|                                                                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'|  If you are not a registered user of GDImage, then you are not allowed   |
'|  to produce derivated work or any translation of this code to another    |
'|  language, without prior written permission of the author.               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-25-2008 (MM-DD-YYYY)            |
'|                        Last revised : 02-04-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "WinScape.exe"
'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZANISKIN.INC"

#INCLUDE "GDIMAGE.INC"

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%XMIN_SIZE = 800
%YMIN_SIZE = 600

%ID_GDIMAGE             = 9
%ID_FRAMEBUTTON         = 10
%ID_BTN_RESET           = 12

%ID_LIB_ROTATION        = 15
%ID_TRACK_ROTATION      = 16

%ID_STRETCH_MODE        = 17

%ID_BACK_LIST           = 36

%ID_BTN_ABOUT           = 37
%ID_STATUSBAR           = 38
%ID_STATUSTIP           = 39

%ID_BTN_BACKL           = 42
%ID_BTN_BACKR           = 43
%ID_THUMBCTRL           = 44
%ID_LIB_BACK            = 45

%ID_BTN_HELP            = 46

%ID_COMPOSITED          = 47
%ID_BTN_SAVE            = 48
%ID_STATUSMESSAGE       = 49
%ID_BTN_CROP            = 50

%ID_CLOCK               = 54


%FRAME_SizeX = 800 '// The animation frame width
%FRAME_SizeY = 600 '// The animation frame height
%TIMER_DELAY = 100'100'80'200'160'160'80'40  '// The timer delay (animation speed)

GLOBAL gMainWnd AS DWORD
GLOBAL gnUseBack, ghImage AS LONG
GLOBAL mt() AS ZGLTEXTUREX

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZDREAM"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED '// Let the OS take care of the region for us
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN

'/*/          CALL ColorInit()
       
          IF (dwExStyle AND %WS_EX_LAYERED) THEN
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "WinScape.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

'/////////////////////////////////////////////////////////////////////////////////////////
          DIM mt(0 TO 6) AS ZGLTEXTUREX
          mt(1).FullName = EXE.Path$ + "Background\sky.jpg"
          mt(2).FullName = EXE.Path$ + "Background\vista_lights.jpg"
          mt(3).FullName = EXE.Path$ + "Background\canyon.jpg"
          mt(4).FullName = EXE.Path$ + "Background\smoke.jpg"
          mt(5).FullName = EXE.Path$ + "Background\morning.jpg"
          mt(6).FullName = EXE.Path$ + "Background\galaxy.jpg"

          gnUseBack = 1: CALL DisplayBackgroundName()

'/////////////////////////////////////////////////////////////////////////////////////////

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

          CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          CALL KillTimer(gMainWnd, 1)

'/////////////////////////////////////////////////////////////////////////////////////////
          '//FreeUp resources
'//          IF ghImage THEN CALL GdipDisposeImage(ghImage)
'/////////////////////////////////////////////////////////////////////////////////////////


          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl, imgW, imgH AS LONG
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 594, 40, 194, 81, %ID_GDIMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 627, 122, 158, 399, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________

'    sLabel = "Animation speed"
'    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 378, 140, 15, %ID_LIB_ROTATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
'    CALL zSetZorder(hCtrl, %HWND_TOP)
'    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
'    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 391, 140, 14, %ID_TRACK_ROTATION, 0, 400, 25, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
'    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
'    CALL zSetZorder(hCtrl, %HWND_TOP)
'    CALL zCreateToolTip(hCtrl, "Adjust speed rotation")


    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Use stretching mode", 636, 391, 140, 15, %ID_STRETCH_MODE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change the stretching mode")


    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Rotate.png"), 376, 518, %ID_BTN_RESET, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Reset")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Left.png"), 321, 530, %ID_BTN_BACKL, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Right.png"), 425, 530, %ID_BTN_BACKR, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")

    hCtrl = zClockCtrl(gMainWnd, (SK_FOLDER() + "SmallClock.png"), 660, 160, 0, 0, %ID_CLOCK, &H7FCB0000, &H7FFFFF00, %DISABLE_TIMER)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "This is a zClockCtrl")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), 5, 4, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 662, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    '// GDImage control
    Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER
    StyleEx& = 0
    hCtrl = CreateWindowEx(StyleEx&, _
                       $GDImageClassName, _     ' GDImage class name
                       "", _                    ' Optional full path name to picture
                       Style&, _                ' window style
                       662, _                   ' initial x position
                       424, _                   ' initial y position
                       87, _                    ' Calculate Window Width
                       66, _                    ' Calculate Window Height
                       gMainWnd, _              ' parent window handle
                       %ID_THUMBCTRL, _         ' ControlID
                       zInstance, _             ' program instance handle
                       BYVAL 0)                 ' creation parameters
    CALL zCreateToolTip(hCtrl, "GDImage graphic control")
    CALL ZI_SetProperty(hCtrl, %ZI_FitToWindow, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    hCtrl = zStaticLabelEx(gMainWnd, "", 634, 494, 144, 18, %ID_LIB_BACK, SK_BTNTEXTCOLOR(), %BS_LABEL_CENTER, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    sImageName = SK_FOLDER() + "StatusBar.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 0, %YMIN_SIZE - imgH, %XMIN_SIZE, imgH, %ID_STATUSBAR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    sImageName = SK_FOLDER() + "Tip.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 6, %YMIN_SIZE - imgH - 1, imgW, imgH, %ID_STATUSTIP, 0)
    CALL ShowWindow(hCtrl, %SW_HIDE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    hCtrl = zStaticLabelEx(gMainWnd, "", 26, %YMIN_SIZE - 19, %XMIN_SIZE - 45, 15, %ID_STATUSMESSAGE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, -1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL zUpdateWindow(hWnd, 0)
    END IF
END SUB

SUB DisplayBackgroundName()
    LOCAL sDataString AS STRING
    CALL ZI_SetFromFile(GetDlgItem(gMainWnd, %ID_THUMBCTRL), mt(gnUseBack).FullName)
    CALL zSplitN(mt(gnUseBack).FullName, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
    CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

    CALL zDisposeImage(zGetProperty(gMainWnd, %FORM_Center))
    CALL zSetProperty(gMainWnd, %FORM_Center, zLoadImageFromFile(mt(gnUseBack).FullName, imgW&, imgH&, 0))
    CALL zAnimResetXX(1, 1) '// Reset the xx location

END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL nRet, hDC, nFilesDropped, hList, nItem, Img, DoIt AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sDataString AS STRING

    IF IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) THEN
       IF ZI_IsLButtonDown() = 0 THEN CALL ShowTip(%FALSE)
    END IF

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_TRACK_ROTATION
              CALL DisplayMessageTip()

         CASE %ID_STRETCH_MODE
              CALL zAnimUseStretchMode(zGetCheckButtonStatus(zGetMainItem(%ID_STRETCH_MODE)) , 1)
      
         CASE %ID_BTN_RESET
              gnUseBack = 1
              CALL DisplayBackgroundName()
              CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ROTATION), 25)'gnWasAngle)

         CASE %ID_BTN_BACKL
              gnUseBack -= 1: IF gnUseBack < 1 THEN gnUseBack = UBOUND(mt()) 
              CALL DisplayBackgroundName()

         CASE %ID_BTN_BACKR
              gnUseBack += 1: IF gnUseBack > UBOUND(mt()) THEN gnUseBack = 1
              CALL DisplayBackgroundName()

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_HELP

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderBackground(hWnd)

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB ShowTip(BYVAL bShowHide AS LONG)
    LOCAL nUseState AS LONG, sMessage AS STRING
    IF bShowHide THEN
       nUseState = %SW_SHOW 
       sMessage = "TIP: clic with the right mouse button to restore the default value while hover a slider."
    ELSE 
       nUseState = %SW_HIDE
       sMessage = ""
    END IF 
    CALL ShowWindow(zGetMainItem(%ID_STATUSTIP), nUseState)
    CALL zSetCTLText(zGetMainItem(%ID_STATUSMESSAGE), (sMessage))
END SUB

SUB DisplayMessageTip()
    IF ZI_IsLButtonDown() AND IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) = 0 THEN CALL ShowTip(%TRUE)
END SUB

%PixelFormatIndexed     = &h00010000 ' Indexes into a palette
%PixelFormatGDI         = &h00020000 ' Is a GDI-supported format
%PixelFormatAlpha       = &h00040000 ' Has an alpha component
%PixelFormatPAlpha      = &h00080000 ' Pre-multiplied alpha
%PixelFormatExtended    = &h00100000 ' Extended color 16 bits/channel
%PixelFormatCanonical   = &h00200000
%PixelFormatUndefined   = 0
%PixelFormatDontCare    = 0
%SHIFT_LEFT_1_8  = 256
%SHIFT_LEFT_4_8  = 1024
%SHIFT_LEFT_8_8  = 2048
%SHIFT_LEFT_16_8 = 4096
%SHIFT_LEFT_24_8 = 6144
%SHIFT_LEFT_32_8 = 8192
%SHIFT_LEFT_48_8 = 12288
%SHIFT_LEFT_64_8 = 16384
%PixelFormat1bppIndexed     =  1 OR %SHIFT_LEFT_1_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat4bppIndexed     =  2 OR %SHIFT_LEFT_4_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat8bppIndexed     =  3 OR %SHIFT_LEFT_8_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat16bppGrayScale  =  4 OR %SHIFT_LEFT_16_8 OR %PixelFormatExtended
%PixelFormat16bppRGB555     =  5 OR %SHIFT_LEFT_16_8 OR %PixelFormatGDI
%PixelFormat16bppRGB565     =  6 OR %SHIFT_LEFT_16_8 OR %PixelFormatGDI
%PixelFormat16bppARGB1555   =  7 OR %SHIFT_LEFT_16_8 OR %PixelFormatAlpha OR %PixelFormatGDI
%PixelFormat24bppRGB        =  8 OR %SHIFT_LEFT_24_8 OR %PixelFormatGDI
%PixelFormat32bppRGB        =  9 OR %SHIFT_LEFT_32_8 OR %PixelFormatGDI
%PixelFormat32bppARGB       = 10 OR %SHIFT_LEFT_32_8 OR %PixelFormatAlpha OR %PixelFormatGDI OR %PixelFormatCanonical
%PixelFormat32bppPARGB      = 11 OR %SHIFT_LEFT_32_8 OR %PixelFormatAlpha OR %PixelFormatPAlpha OR %PixelFormatGDI
%PixelFormat48bppRGB        = 12 OR %SHIFT_LEFT_48_8 OR %PixelFormatExtended
%PixelFormat64bppARGB       = 13 OR %SHIFT_LEFT_64_8 OR %PixelFormatAlpha OR %PixelFormatCanonical OR %PixelFormatExtended
%PixelFormat64bppPARGB      = 14 OR %SHIFT_LEFT_64_8 OR %PixelFormatAlpha OR %PixelFormatPAlpha OR %PixelFormatExtended
%PixelFormatMax             = 15

SUB RenderBackground(BYVAL hWnd AS LONG)

    LOCAL hWndDC, Img AS LONG
    STATIC x, y, imgW, imgH AS LONG
     
    '// Draw active frame to new memory DC
    'IF ghImage = 0 THEN
    '   ghImage = zLoadImageFromFile(mt(gnUseBack).FullName, imgW, imgH, 0)
    
    'END IF

    'IF ghImage THEN

       'CALL GdipGetImageWidth(ghImage, imgW)
       'CALL GdipGetImageHeight(ghImage, imgH)
 
       'IF x > imgW - %FRAME_SizeX THEN x = 0

       'IF GdipCloneBitmapAreaI(x, y, %FRAME_SizeX, %FRAME_SizeY, %PixelFormat32bppARGB, ghImage, Img) = 0 THEN
       '   CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
       '   CALL zSetProperty(hWnd, %FORM_Center, Img)
          'CALL InvalidateRect(hWnd, BYVAL 0&, 1)
'          CALL zPaintBackground(0)
          
    hWndDC = GetDC(hWnd)
    CALL zPaintDoubleBuffer(hWnd, hWndDC)
    CALL ReleaseDC(hWnd, hWndDC)

          
       'END IF

    '   x += 1: y = 0
    'END IF


END SUB

